<template>
    <ion-page>
        <ion-header :translucent="true">
            <ion-toolbar>
                <ion-buttons slot="start">
                    <ion-menu-button color="primary"></ion-menu-button>

                    <ion-button
                        color="tertiary"
                        @click="$router.push({ name: Route.groupList })"
                    >
                        <ion-icon
                            slot="icon-only"
                            :ios="returnUpBack"
                            :md="returnUpBack"
                        ></ion-icon>
                    </ion-button>
                </ion-buttons>

                <ion-title>Skupina zařízení</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content :fullscreen="true">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>
            <h2 class="center" v-if="isNew">Nová skupina zařízení</h2>

            <ion-text
                color="tertiary"
                v-for="error of v$.$errors"
                :key="error.$uid"
                class="color: danger;"
                ><p>
                    <span>Chyba: </span>
                    <strong>{{ error.$property }} {{ error.$message }}</strong>
                </p>
            </ion-text>

            <ion-list>
                <ion-item>
                    <ion-input
                        v-model="curValue.name"
                        aria-label="Jméno skupiny (name)"
                        label="Jméno skupiny (name)"
                        placeholder="Zadejte"
                    ></ion-input>
                </ion-item>

                <ion-item>
                    <device-select
                        v-model="curValue.deviceIdList"
                    ></device-select>
                </ion-item>
                <ion-item v-if="userStore.data.isAdmin">
                    <user-select v-model="curValue.ownerId"></user-select>
                </ion-item>
                <ion-item>
                    <ion-toggle v-model="curValue.isActive"
                        >Skupina aktivní</ion-toggle
                    >
                </ion-item>
            </ion-list>

            <ion-button @click="send">Odeslat</ion-button>
        </ion-content>
    </ion-page>
</template>

<script setup lang="ts">
import DeviceSelect from '@/component/Forms/DeviceSelect.vue'
import UserSelect from '@/component/Forms/UserSelect.vue'
import { CreateDeviceGroup, Device } from '@/gql/graphql'
import toast from '@/helpers/toast'
import router from '@/router'
import { Route } from '@/router/route'
import { useUserStore } from '@/stores/userStore'
import {
    IonIcon,
    IonButton,
    IonButtons,
    IonProgressBar,
    IonContent,
    IonHeader,
    IonMenuButton,
    IonPage,
    IonTitle,
    IonToolbar,
    IonInput,
    IonItem,
    IonList,
    IonToggle,
    IonText,
} from '@ionic/vue'
import { MutateResult, useLazyQuery, useMutation } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { returnUpBack } from 'ionicons/icons'
import { reactive, ref, toRaw } from 'vue'
import { useRoute } from 'vue-router'
import { useVuelidate } from '@vuelidate/core'
import { required$, maxLength$, minLength$ } from '@/helpers/validator'

const route = useRoute()
const userStore = useUserStore()

const curValue = reactive<any>({
    name: '',
    deviceIdList: [],
    ownerId: '',
    isActive: false,
})

const rules = {
    name: {
        req: required$,
        min: minLength$(3),
        max: maxLength$(20),
    },
}

const v$ = useVuelidate(rules, curValue)

// Původní hodnota pro update
let originalValue: CreateDeviceGroup | null = null

const isNew = ref(true)

const { loading, load, variables } = useLazyQuery(gql`
    query deviceGroup($id: ID!) {
        deviceGroup(id: $id) {
            id
            name
            deviceList {
                id
            }
            owner {
                id
            }
            isActive
        }
    }
`)

// Načíst data do formuláře
if (route.params.id !== undefined && route.params.id !== '') {
    isNew.value = false
    variables.value = { id: route.params.id }
    const data = load()

    if (data) {
        data.then((result) => {
            curValue.name = result.deviceGroup?.name
            curValue.deviceIdList = result.deviceGroup?.deviceList?.map(
                (val: Device) => val.id
            )
            curValue.ownerId = result.deviceGroup?.owner?.id

            // Nereaktivní
            originalValue = { ...toRaw(curValue) }
        })
    }
}

const { mutate: createGroup } = useMutation(gql`
    mutation createGroup($data: createDeviceGroup!) {
        createDeviceGroup(deviceGroup: $data) {
            name
        }
    }
`)

const { mutate: updateGroup } = useMutation(gql`
    mutation updateGroup($id: ID!, $data: updateDeviceGroup!) {
        updateDeviceGroup(id: $id, deviceGroup: $data) {
            name
        }
    }
`)

const { mutate: addDeviceToGroup } = useMutation(gql`
    mutation addDeviceToGroup1($deviceId: ID!, $groupId: ID!) {
        addDeviceToGroup(deviceId: $deviceId, groupId: $groupId)
    }
`)

const { mutate: removeDeviceFromGroup } = useMutation(gql`
    mutation removeDeviceFromGroup1($deviceId: ID!, $groupId: ID!) {
        removeDeviceFromGroup(deviceId: $deviceId, groupId: $groupId)
    }
`)

const send = async () => {
    const isFormCorrect = await v$.value.$validate()

    if (!isFormCorrect) {
        return
    }

    // Uživatelé mohou přidávat skupiny jen sobě
    if (!userStore.data.isAdmin) {
        curValue.ownerId = userStore.data.id
    }

    // Pokud je ID v adrese, tak update, jinak create
    if (route.params.id !== undefined && route.params.id !== '') {
        const newDeviceIdList = toRaw(curValue.deviceIdList)
        const originalDeviceIdList = originalValue?.deviceIdList ?? []

        updateGroup({
            id: route.params.id,
            data: {
                name: curValue.name,
                ownerId: curValue.ownerId,
                isActive: curValue.isActive,
            },
        }).then((values) => {
            const groupId = route.params.id
            const requestList: MutateResult<void>[] = []

            // To ADD
            newDeviceIdList
                .filter((x: any) => !originalDeviceIdList.includes(x))
                .forEach((deviceId: string) =>
                    requestList.push(addDeviceToGroup({ deviceId, groupId }))
                )

            // To DEL
            originalDeviceIdList
                .filter((x: any) => !newDeviceIdList.includes(x))
                .forEach((deviceId: string) =>
                    requestList.push(
                        removeDeviceFromGroup({ deviceId, groupId })
                    )
                )

            // Počkat na dokončení všech requestů
            Promise.all(requestList).then(() => {
                router.push({ name: Route.groupList })
                toast(
                    'Skupina ' +
                        values?.data.updateDeviceGroup.name +
                        ' upravena',
                    'success'
                )
            })
        })
    } else {
        console.log(curValue)
        createGroup({ data: curValue }).then((values) => {
            router.push({ name: Route.groupList })
            toast(
                'Skupina ' + values?.data.createDeviceGroup.name + ' vytvořena',
                'success'
            )
        })
    }
}
</script>
<style>
.center {
    margin-top: 1em;
    text-align: center;
}
</style>
